#ifndef MYDATA_H
#define MYDATA_H

#include <QObject>

#include "MyEnum.h"

class MyData : public QObject
{
    Q_OBJECT
   Q_PROPERTY(MyEnum::Option1 opt1 READ opt1 WRITE setOpt1 NOTIFY opt1Changed)
public:
	explicit MyData(QObject *parent = Q_NULLPTR);

	enum Option2Flag {
		Option2A = 1, // 000001
		Option2B = 2, // 000010
		Option2C = 4, // 000100
        Option2D = 8, // 001000
		Option2E = 16, // 010000
		Option2F = 32, // 100000
		// … some more options with value which is a power of two
		Option2AD = Option2A | Option2D,
	};
    Q_DECLARE_FLAGS(Option2, Option2Flag)
	Q_FLAG(Option2)

     // Q_DECLARE_OPERATORS_FOR_FLAGS(Option1)
    //Q_ENUM(Option2Flag)

    MyEnum::Option1 opt1() const;

signals:
    void opt1Changed();

public slots:
    void setOpt1(MyEnum::Option1 val);
    void setOption1(int id, MyEnum::Option1 option);
    void setOption1i(int id, int option);

	void setOption2(int id, MyData::Option2 option);
};

Q_DECLARE_OPERATORS_FOR_FLAGS(MyData::Option2)
Q_DECLARE_METATYPE(MyData::Option2)
Q_DECLARE_METATYPE(MyData::Option2Flag)
#endif // MYDATA_H
